#!/usr/bin/python
# -*- encoding: utf-8 -*-

# Codé par 20-100

# Un bot IRC pour remplacer le canard.
# parce que le canard, c'est le bien et que braice ne pong pas

import threading
import random
import time
import socket, ssl, json
import pickle
import re
import os
import signal
import sys
from commands import getstatusoutput as ex

# Oui, j'ai recodé ma version d'irclib pour pouvoir rattrapper les SIGHUP
sys.path.insert(0, "/home/vincent/scripts/python-myirclib")
import irclib
import ircbot

# on récupère la config
import config



def get_config_logfile(serveur):
    serveurs={"acoeur.crans.org":"acoeur","irc.crans.org":"crans"}
    return config.logfile_template%(serveurs[serveur])

def log(serveur,channel,auteur=None,message=None):
    f=open(get_config_logfile(serveur),"a")
    if auteur==message==None:
        # alors c'est que c'est pas un channel mais juste une ligne de log
        chain="%s %s"%(time.strftime("%F %T"),channel)
    else:
        chain="%s [%s:%s] %s"%(time.strftime("%F %T"),channel,auteur,message)
    f.write(chain+"\n")
    if config.debug_stdout:
        print chain
    f.close()

def is_something(chain,matches,avant=u".*(?:^| )",apres=u"(?:$|\.| |,|;).*",case_sensitive=False,debug=False):
    if case_sensitive:
        chain=unicode(chain,"utf8")
    else:
        chain=unicode(chain,"utf8").lower()
    allmatches="("+"|".join(matches)+")"
    reg=(avant+allmatches+apres).lower()
    o=re.match(reg,chain)
    return o

regexp_pan = re.compile(u".*(" + "|".join(config.killwords) + u").*")
def is_pan(chain):
    return regexp_pan.match(unicode(chain,"utf8").lower())

def ignore_event(serv, ev):
    """Retourne ``True`` si il faut ignorer cet évènement."""
    for (blackmask, exceptmask) in config.blacklisted_masks:
        usermask = ev.source()
        if exceptmask is None:
            exceptit = False
        else:
            exceptit = bool(irclib.mask_matches(usermask, exceptmask))
        blackit = bool(irclib.mask_matches(usermask, blackmask))
        if blackit and not exceptit:
            return True

class UnicodeBotError(Exception):
    pass
def bot_unicode(chain):
    try:
        unicode(chain,"utf8")
    except UnicodeDecodeError as exc:
        raise UnicodeBotError

class Saturnin(ircbot.SingleServerIRCBot):
    def __init__(self,serveur,debug=False):
        temporary_pseudo=config.irc_pseudo+str(random.randrange(10000,100000))
        ircbot.SingleServerIRCBot.__init__(self, [(serveur, 6667)],
                              temporary_pseudo,"Coin ? ©braice [mais 'faut frapper 20-100]", 10)
        self.debug=debug
        self.serveur=serveur
        self.overops=config.overops
        self.ops=self.overops+config.ops
        self.chanlist=config.chanlist
        self.stay_channels=config.stay_channels
        self.quiet_channels=config.quiet_channels
        self.play_channels=config.play_channels
        self.status = { chan : [0, None] for chan in self.play_channels }
        # 0 : pas de spawn prévu
        # 1 : un spawn prévu,
        #     avec en deuxième paramètre le timestamp du moment où il a été déclenché (pas du moment où il se fera)
        # 2 : alive
        self.last_perdu=0
    
    def give_me_my_pseudo(self,serv):
        serv.privmsg("NickServ","RECOVER %s %s"%(config.irc_pseudo,config.irc_password))
        serv.privmsg("NickServ","RELEASE %s %s"%(config.irc_pseudo,config.irc_password))
        time.sleep(0.3)
        serv.nick(config.irc_pseudo)
    
    def on_welcome(self, serv, ev):
        self.serv=serv # ça serv ira :)
        self.give_me_my_pseudo(serv)
        serv.privmsg("NickServ","IDENTIFY %s"%(config.irc_password))
        log(self.serveur,"Connected")
        if self.debug:
            self.chanlist = self.play_channels = ["#bot"]
            self.status = { chan : [0, 0] for chan in self.play_channels }
        for c in self.chanlist:
            log(self.serveur,"JOIN %s"%(c))
            serv.join(c)
            if c in self.play_channels:
                spawn_delay = random.randrange(*config.spawn_delays)
                self.spawn(c, time.time(), spawn_delay)
    
    def pourmoi(self, serv, message):
        """renvoie (False,lemessage) ou (True, le message amputé de "pseudo: ")"""
        pseudo=self.nick
        size=len(pseudo)
        if message[:size]==pseudo and len(message)>size and message[size]==":":
            return (True,message[size+1:].lstrip(" "))
        else:
            return (False,message)
    
    def on_privmsg(self, serv, ev):
        if ignore_event(serv, ev):
            return
        message=ev.arguments()[0]
        auteur = irclib.nm_to_n(ev.source())
        try:
            test=bot_unicode(message)
        except UnicodeBotError:
            if config.utf8_trigger:
                serv.privmsg(auteur, random.choice(config.utf8_fail_answers).encode("utf8"))
            return
        message=message.split()
        cmd=message[0].lower()
        notunderstood=False
        if cmd=="help":
            helpdico={"help":["""HELP <commande>
 Affiche de l'aide sur la commande""",None,None],
 "score":["""SCORE
 Affiche votre score""", None, None],
 "scores":["""SCORES
 Afficher tous les scores""", None, None],
 "join": [None, """JOIN <channel>
 Me fait rejoindre le channel""",None],
 "leave": [None,"""LEAVE <channel>
 Me fait quitter le channel (sauf s'il est dans ma stay_list).""",None],
 "quiet": [None,"""QUIET <channel>
 Me rend silencieux sur le channel.""",None],
 "noquiet": [None,"""NOQUIET <channel>
 Me rend la parole sur le channel.""",None],
 "play": [None, """PLAY
 Passe un channel en mode "jouer" """,None],
 "noplay": [None, """NOPLAY
 Passe un channel en mode "ne pas jouer" """,None],
 "SPAWN": [None, """SPAWN <channel>
 Me fait spawner sur le channel.""",None],
 "reload": [None,"""RELOAD
 Recharge la configuration.""",None],
 "say": [None,None,"""SAY <channel> <message>
 Me fait parler sur le channel."""],
 "do": [None,None,"""DO <channel> <action>
 Me fait faitre une action (/me) sur le channel."""],
 "stay": [None,None,"""STAY <channel>
 Ajoute le channel à ma stay_list."""],
 "nostay": [None,None,"""NOSTAY <channel>
 Retire le channel de ma stay_list."""],
 "ops": [None,None,"""OPS
 Affiche la liste des ops."""],
 "overops": [None,None,"""OVEROPS
 Affiche la liste des overops."""],
 "kick": [None,None,"""KICK <channel> <pseudo> [<raison>]
 Kicke <pseudo> du channel (Il faut bien entendu que j'y sois op)."""],
 "die": [None,None,"""DIE
 Me déconnecte du serveur IRC."""]
 }
            helpmsg_default="Liste des commandes disponibles :\nHELP SCORE SCORES"
            helpmsg_ops=" JOIN LEAVE QUIET NOQUIET PLAY NOPLAY SPAWN"
            helpmsg_overops=" SAY DO STAY NOSTAY OPS OVEROPS KICK DIE"
            op,overop=auteur in self.ops, auteur in self.overops
            if len(message)==1:
                helpmsg=helpmsg_default
                if op:
                    helpmsg+=helpmsg_ops
                if overop:
                    helpmsg+=helpmsg_overops
            else:
                helpmsgs=helpdico.get(message[1].lower(),["Commande inconnue.",None,None])
                helpmsg=helpmsgs[0]
                if op and helpmsgs[1]:
                    if helpmsg:
                        helpmsg+="\n"+helpmsgs[1]
                    else:
                        helpmsg=helpmsgs[1]
                if overop and helpmsgs[2]:
                    if helpmsg:
                        helpmsg+="\n"+helpmsgs[2]
                    else:
                        helpmsg=helpmsgs[2]
            for ligne in helpmsg.split("\n"):
                serv.privmsg(auteur,ligne)
        elif cmd=="join":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.chanlist:
                        serv.privmsg(auteur,"Je suis déjà sur %s"%(message[1]))
                    else:
                        serv.join(message[1])
                        self.chanlist.append(message[1])
                        serv.privmsg(auteur,"Channels : "+" ".join(self.chanlist))
                        log(self.serveur,"priv",auteur," ".join(message))
                else:
                    serv.privmsg(auteur,"Channels : "+" ".join(self.chanlist))
            else:
                notunderstood=True
        elif cmd=="leave":
            if auteur in self.ops and len(message)>1:
                if message[1] in self.chanlist:
                    if not (message[1] in self.stay_channels) or auteur in self.overops:
                        self.quitter(message[1]," ".join(message[2:]))
                        self.chanlist.remove(message[1])
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                    else:
                        serv.privmsg(auteur,"Non, je reste !")
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                else:
                    serv.privmsg(auteur,"Je ne suis pas sur %s"%(message[1]))
            else:
                notunderstood=True
        elif cmd=="stay":
            if auteur in self.overops:
                if len(message)>1:
                    if message[1] in self.stay_channels:
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                        serv.privmsg(auteur,"Je stay déjà sur %s."%(message[1]))
                    else:
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                        self.stay_channels.append(message[1])
                        serv.privmsg(auteur,"Stay channels : "+" ".join(self.stay_channels))
                else:
                    serv.privmsg(auteur,"Stay channels : "+" ".join(self.stay_channels))
            else:
                notunderstood=True
        elif cmd=="nostay":
            if auteur in self.overops:
                if len(message)>1:
                    if message[1] in self.stay_channels:
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                        self.stay_channels.remove(message[1])
                        serv.privmsg(auteur,"Stay channels : "+" ".join(self.stay_channels))
                    else:
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                        serv.privmsg(auteur,"Je ne stay pas sur %s."%(message[1]))

            else:
                notunderstood=True
        elif cmd=="die":
            if auteur in self.overops:
                log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                self.mourir()
            else:
                notunderstood=True
        elif cmd=="quiet":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.quiet_channels:
                        serv.privmsg(auteur,"Je me la ferme déjà sur %s"%(message[1]))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                    else:
                        self.quiet_channels.append(message[1])
                        serv.privmsg(auteur,"Quiet channels : "+" ".join(self.quiet_channels))
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                else:
                    serv.privmsg(auteur,"Quiet channels : "+" ".join(self.quiet_channels))
            else:
                notunderstood=True
        elif cmd=="noquiet":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.quiet_channels:
                        self.quiet_channels.remove(message[1])
                        serv.privmsg(auteur,"Quiet channels : "+" ".join(self.quiet_channels))
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                    else:
                        serv.privmsg(auteur,"Je ne me la ferme pas sur %s."%(message[1]))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
            else:
                notunderstood=True
        elif cmd=="play":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.play_channels:
                        serv.privmsg(auteur,"Je play déjà sur %s."%(message[1]))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
                    else:
                        self.play_channels.append(message[1])
                        self.spawn(message[1], 1)
                        serv.privmsg(auteur,"Play channels : "+" ".join(self.play_channels))
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                else:
                    serv.privmsg(auteur,"Play channels : "+" ".join(self.play_channels))
            else:
                notunderstood=True
        elif cmd=="noplay":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.play_channels:
                        self.play_channels.remove(message[1])
                        serv.privmsg(auteur,"Play channels : "+" ".join(self.play_channels))
                        log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
                    else:
                        serv.privmsg(auteur,"Je ne play pas sur %s."%(message[1]))
                        log(self.serveur,"priv",auteur," ".join(message)+"[failed]")
            else:
                notunderstood=True
        elif cmd=="status":
            if auteur in self.ops:
                serv.privmsg(auteur,"Status : %s" % (self.status, ))
            else:
                notunderstood=True
        elif cmd=="spawn":
            if auteur in self.ops:
                if len(message)>1:
                    if message[1] in self.play_channels:
                        # Le plus pratique pour pas s'embêter c'est de mettre un
                        #  delay d'une seconde, comme ça .spawn() fait le boulot
                        self.spawn(message[1], time.time(), 1)
                    else:
                        serv.privmsg(auteur, "Je ne joue pas sur %s" % message[1])
                else:
                    serv.privmsg(auteur, "Syntaxe : SPAWN <channel>")
            else:
                notunderstood=True
        elif cmd=="say":
            if auteur in self.overops and len(message)>2:
                serv.privmsg(message[1]," ".join(message[2:]))
                log(self.serveur,"priv",auteur," ".join(message))
            elif len(message)<=2:
                serv.privmsg(auteur,"Syntaxe : SAY <channel> <message>")
            else:
                notunderstood=True
        elif cmd=="do":
            if auteur in self.overops and len(message)>2:
                serv.action(message[1]," ".join(message[2:]))
                log(self.serveur,"priv",auteur," ".join(message))
            elif len(message)<=2:
                serv.privmsg(auteur,"Syntaxe : DO <channel> <action>")
            else:
                notunderstood=True
        elif cmd=="kick":
            if auteur in self.overops and len(message)>2:
                serv.kick(message[1],message[2]," ".join(message[3:]))
                log(self.serveur,"priv",auteur," ".join(message))
            elif len(message)<=2:
                serv.privmsg(auteur,"Syntaxe : KICK <channel> <pseudo> [<raison>]")
            else:
                notunderstood=True
        elif cmd=="ops":
            if auteur in self.overops:
                serv.privmsg(auteur," ".join(self.ops))
            else:
                notunderstood=True
        elif cmd=="overops":
            if auteur in self.overops:
                serv.privmsg(auteur," ".join(self.overops))
            else:
                notunderstood=True
        elif cmd=="reload":
            if auteur in self.ops:
                self.reload(auteur)
                log(self.serveur,"priv",auteur," ".join(message)+"[successful]")
            else:
                notunderstood=True
        elif cmd=="score":
            if len(message)>1:
                if len(message) in [3,4] and message[1].lower()=="transfert":
                    scores=self.get_scores()
                    de,to=auteur,message[2]
                    value=scores.get(de,0)
                    if len(message)==4:
                        try:
                            asked=int(message[3])
                        except ValueError:
                            serv.privmsg(auteur,"Syntaxe : SCORE TRANSFERT <pseudo> [<n>]")
                            return
                    else:
                        asked=value
                    if value==0:
                        serv.privmsg(auteur,"Vous n'avez pas de points")
                        return
                    elif asked<=0:
                        serv.privmsg(auteur,"Bien tenté…")
                        return
                    elif asked>value:
                        serv.privmsg(auteur,"Vous n'avez que %s points"%(value))
                        return
                    else:
                        self.add_score(de,-asked)
                        self.add_score(to,asked)
                        serv.privmsg(auteur,"Transfert de %s points de %s à %s"%(asked,de,to))
                elif len(message) == 2:
                    scores = self.get_scores()
                    asked = message[1]
                    if asked in scores:
                        serv.privmsg(auteur, "Score de %s : %s" % (asked, scores[asked]))
                    else:
                        serv.privmsg(auteur, "%s n'a encore jamais joué (avec succès)." % (asked,))
                else:
                    serv.privmsg(auteur,"Syntaxe : SCORE TRANSFERT <pseudo> [<n>]")
            else:
                self.sendscore(auteur)
        elif cmd=="scores":
            if len(message)==1:
                self.sendscores(auteur)
            elif auteur in self.overops:
                souscmd=message[1].lower()
                if souscmd=="del":
                    if len(message)==3:
                        todelete=message[2]
                        scores=self.get_scores()
                        if scores.has_key(todelete):
                            del scores[todelete]
                            self.save_scores(scores)
                            serv.privmsg(auteur,"Score de %s supprimé"%(todelete))
                        else:
                            serv.privmsg(auteur,"Ce score n'existe pas : %s"%(todelete))
                    else:
                        serv.privmsg(auteur,"Syntaxe : SCORES DEL <pseudo>")
                elif souscmd in ["add","sub"]:
                    if len(message)==4:
                        toadd,val=message[2],message[3]
                        try:
                            val=int(val)
                        except ValueError:
                            serv.privmsg(auteur,"Syntaxe : SCORES {ADD|SUB} <pseudo> <n>")
                            return
                        if souscmd=="sub":
                            val=-val
                        self.add_score(toadd,val)
                        serv.privmsg(auteur,"Done")
                    else:
                        serv.privmsg(auteur,"Syntaxe : SCORES {ADD|SUB} <pseudo> <n>")
                else:
                    serv.privmsg(auteur,"Syntaxe : SCORES {DEL|ADD|SUB} <pseudo> [<n>]")
            else:
                notunderstood=True
        else:
            notunderstood=True
        if notunderstood:
            serv.privmsg(auteur,"Je n'ai pas compris. Essayez HELP…")
    
    def sendscore(self, to):
        self.serv.privmsg(to, "Votre score : %s"%(self.get_scores().get(to,0)) )
    
    def sendscores(self, to):
        scores=self.get_scores().items()
        # trie par score
        scores.sort(lambda x,y:cmp(x[1],y[1]))
        scores.reverse()
        self.serv.privmsg(to, "Scores by score : "+" ; ".join(["%s %s"%(i[0],i[1]) for i in scores]))
        # trie par pseudo
        scores.sort(lambda x,y:cmp(x[0].lower(),y[0].lower()))
        self.serv.privmsg(to, "Scores by pseudo : "+" ; ".join(["%s %s"%(i[0],i[1]) for i in scores]))
    
    def on_pubmsg(self, serv, ev):
        if ignore_event(serv, ev):
            return
        auteur = irclib.nm_to_n(ev.source())
        channel = ev.target()
        message = ev.arguments()[0]
        try:
            test=bot_unicode(message)
        except UnicodeBotError:
            if config.utf8_trigger and not channel in self.quiet_channels:
                serv.privmsg(channel, (u"%s: %s"%(auteur,random.choice(config.utf8_fail_answers))).encode("utf8"))
            return
        pour_moi,message=self.pourmoi(serv,message)
        if pour_moi and message.split()!=[]:
            cmd=message.split()[0].lower()
            try:
                args=" ".join(message.split()[1:])
            except:
                args=""
            if cmd in ["meurs","die","crève"]:
                if auteur in self.overops:
                    log(self.serveur,channel,auteur,message+"[successful]")
                    self.mourir()
                else:
                    serv.privmsg(channel,("%s: %s"%(auteur,random.choice(config.quit_fail_messages))).encode("utf8"))
                    log(self.serveur,channel,auteur,message+"[failed]")
            elif cmd == "reload":
                if auteur in self.ops:
                    log(self.serveur, channel, auteur, message+"[successful]")
                    self.reload(channel)
            elif cmd in ["part","leave","dégage","va-t-en","tut'tiresailleurs,c'estmesgalets"]:
                if auteur in self.ops and (not (channel in self.stay_channels)
                                           or auteur in self.overops):
                    self.quitter(channel)
                    log(self.serveur,channel,auteur,message+"[successful]")
                    if channel in self.chanlist:
                        self.chanlist.remove(channel)
                else:
                    serv.privmsg(channel,("%s: %s"%(auteur,random.choice(config.leave_fail_messages))).encode("utf8"))
                    log(self.serveur,channel,auteur,message+"[failed]")
            elif cmd == "score":
                self.sendscore(auteur)
            elif cmd == "scores":
                self.sendscores(auteur)
        else:
            if is_pan(message):
                self.shot(channel, auteur)
    
    def on_action(self, serv, ev):
        if ignore_event(serv, ev):
            return
        action = ev.arguments()[0]
        auteur = irclib.nm_to_n(ev.source())
        channel = ev.target()
        #~ try:
            #~ test=bot_unicode(action)
        #~ except UnicodeBotError:
            #~ if config.utf8_trigger and not channel in self.quiet_channels:
                #~ serv.privmsg(channel, (u"%s: %s"%(auteur,random.choice(config.utf8_fail_answers))).encode("utf8"))
            #~ return
        #~ mypseudo=self.nick
    
    def on_kick(self,serv,ev):
        auteur = irclib.nm_to_n(ev.source())
        channel = ev.target()
        victime = ev.arguments()[0]
        raison = ev.arguments()[1]
        if victime==self.nick:
            log(self.serveur,"%s kické de %s par %s (raison : %s)" %(victime,channel,auteur,raison))
            time.sleep(2)
            serv.join(channel)
            #~ l1,l2=config.kick_answers,config.kick_actions
            #~ n1,n2=len(l1),len(l2)
            #~ i=random.randrange(n1+n2)
            #~ if i>=n1:
                #~ serv.action(channel,l2[i-n1].format(auteur).encode("utf8"))
            #~ else:
                #~ serv.privmsg(channel,l1[i].format(auteur).encode("utf8"))
    
    def spawn(self, channel, timestamp, delay=0):
        if channel in self.play_channels:
            if delay>0:
                self.serv.execute_delayed(delay, self.spawn, (channel, timestamp))
                self.status[channel] = [1, timestamp]
            else:
                # on teste le timestamp pour pas s'emmêler dans les spawn
                infos = self.status.get(channel, [0,0])
                if infos == [1, timestamp]:
                    spawn_sentence = random.choice(config.canards) + random.choice(config.spawn_sentences)
                    self.serv.privmsg(channel, spawn_sentence.encode("utf8"))
                    self.status[channel] = [2, timestamp]
                    times_up_delay = random.randrange(*config.times_up_delays)
                    self.serv.execute_delayed(times_up_delay, self.too_slow, (channel, timestamp))
    
    def too_slow(self, channel, timestamp):
        infos = self.status.get(channel, [0,0])
        if infos == [2, timestamp]:
            self.serv.privmsg(channel, random.choice(config.times_up_sentences).encode("utf8"))
            respawn_delay = random.randrange(*config.spawn_delays)
            self.spawn(channel, time.time(), respawn_delay)
    
    def shot(self, channel, auteur):
        if self.status.get(channel, [0, 0])[0] == 2:
            succeed = random.randrange(0,101) > config.proba_miss
            if succeed:
                self.serv.privmsg(channel, random.choice(config.killed_templates).format(auteur).encode("utf8"))
                self.add_score(auteur, 1)
                if random.randrange(0, 101) < config.proba_killed_sentence:
                    self.serv.privmsg(channel, random.choice(config.killed_sentences).encode("utf8"))
                respawn_delay = random.randrange(*config.spawn_delays)
                self.spawn(channel, time.time(), respawn_delay)
            else:
                self.serv.privmsg(channel, random.choice(config.miss_templates).format(auteur).encode("utf8"))
                if random.randrange(0,101) < config.proba_miss_sentence:
                    self.serv.privmsg(channel, random.choice(config.miss_sentences).encode("utf8"))
    
    def quitter(self,chan,leave_message=None):
        if leave_message==None:
            leave_message=random.choice(config.leave_messages)
        self.serv.part(chan,message=leave_message.encode("utf8"))
    
    def mourir(self):
        quit_message=random.choice(config.quit_messages)
        self.die(msg=quit_message.encode("utf8"))

    def get_scores(self):
        f=open(config.score_file)
        scores=pickle.load(f)
        f.close()
        return scores

    def add_score(self, pseudo, value):
        scores=self.get_scores()
        if scores.has_key(pseudo):
            scores[pseudo]+=value
        else:
            scores[pseudo]=value
        self.save_scores(scores)

    def save_scores(self,scores):
        f=open(config.score_file,"w")
        pickle.dump(scores,f)
        f.close()
    
    def _getnick(self):
        return self.serv.get_nickname()
    nick=property(_getnick)
    
    def reload(self, auteur=None):
        reload(config)
        if auteur in [None, "SIGHUP"]:
            towrite = "Config reloaded" + " (SIGHUP received)"*(auteur == "SIGHUP")
            for to in config.report_bugs_to:
                self.serv.privmsg(to, towrite)
            log(self.serveur, towrite)
        else:
            self.serv.privmsg(auteur,"Config reloaded")
    
    def start_as_daemon(self, outfile):
        sys.stderr = Logger(outfile)
        self.start()


class Logger(object):
    """Pour écrire ailleurs que sur stdout"""
    def __init__(self, filename="saturnin.full.log"):
        self.filename = filename

    def write(self, message):
        f = open(self.filename, "a")
        f.write(message)
        f.close()


if __name__=="__main__":
    import sys
    if len(sys.argv)==1:
        print "Usage : saturnin.py <serveur> [--debug] [--no-output] [--daemon [--pidfile]] [--outfile]"
        print "        --outfile sans --no-output ni --daemon n'a aucun effet"
        exit(1)
    serveur=sys.argv[1]
    if "--daemon" in sys.argv:
        thisfile = os.path.realpath(__file__)
        thisdirectory = thisfile.rsplit("/", 1)[0]
        os.chdir(thisdirectory)
        daemon = True
    else:
        daemon = False
    if "debug" in sys.argv or "--debug" in sys.argv:
        debug=True
    else:
        debug=False
    if "--no-output" in sys.argv or "--daemon" in sys.argv:
        outfile = "/var/log/bots/saturnin.full.log"
        for arg in sys.argv:
            arg = arg.split("=")
            if arg[0].strip('-') in ["out", "outfile", "logfile"]:
                outfile = arg[1]
        sys.stdout = Logger(outfile)
    if "--quiet" in sys.argv:
        config.debug_stdout=False
    serveurs={"a♡":"acoeur.crans.org","acoeur":"acoeur.crans.org","acoeur.crans.org":"acoeur.crans.org",
              "irc":"irc.crans.org","crans":"irc.crans.org","irc.crans.org":"irc.crans.org",
              "local":"localhost"}
    try:
        serveur=serveurs[serveur]
    except KeyError:
        print "Server Unknown : %s"%(serveur)
        exit(404)
    saturnin = Saturnin(serveur,debug)
    # Si on reçoit un SIGHUP, on reload la config
    def sighup_handler(signum, frame):
        saturnin.reload("SIGHUP")
    signal.signal(signal.SIGHUP, sighup_handler)
    if daemon:
        child_pid = os.fork()
        if child_pid == 0:
            os.setsid()
            saturnin.start_as_daemon(outfile)
        else:
            # on enregistre le pid de saturnin
            pidfile = "/var/run/bots/saturnin.pid"
            for arg in sys.argv:
                arg = arg.split("=")
                if arg[0].strip('-') in ["pidfile"]:
                    pidfile = arg[1]
            f = open(pidfile, "w")
            f.write("%s\n" % child_pid)
            f.close()
    else:
        saturnin.start()

